/* App.c generated by valac 0.56.18, the Vala compiler
 * generated from App.vala, do not modify */

/*
 * Copyright (c) 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "notifications.h"
#include <gio/gdesktopappinfo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BACKEND_APP_0_PROPERTY,
	BACKEND_APP_APP_INFO_PROPERTY,
	BACKEND_APP_APP_ID_PROPERTY,
	BACKEND_APP_SETTINGS_PROPERTY,
	BACKEND_APP_NUM_PROPERTIES
};
static GParamSpec* backend_app_properties[BACKEND_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _BackendAppPrivate {
	GDesktopAppInfo* _app_info;
	gchar* _app_id;
	GSettings* _settings;
};

static gint BackendApp_private_offset;
static gpointer backend_app_parent_class = NULL;

static void backend_app_set_app_id (BackendApp* self,
                             const gchar* value);
static void backend_app_set_settings (BackendApp* self,
                               GSettings* value);
static GObject * backend_app_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void backend_app_finalize (GObject * obj);
static GType backend_app_get_type_once (void);
static void _vala_backend_app_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_backend_app_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
backend_app_get_instance_private (BackendApp* self)
{
	return G_STRUCT_MEMBER_P (self, BackendApp_private_offset);
}

BackendApp*
backend_app_construct (GType object_type,
                       GDesktopAppInfo* app_info)
{
	BackendApp * self = NULL;
#line 25 "../src/Backend/App.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 26 "../src/Backend/App.vala"
	self = (BackendApp*) g_object_new (object_type, "app-info", app_info, NULL);
#line 25 "../src/Backend/App.vala"
	return self;
#line 98 "App.c"
}

BackendApp*
backend_app_new (GDesktopAppInfo* app_info)
{
#line 25 "../src/Backend/App.vala"
	return backend_app_construct (BACKEND_TYPE_APP, app_info);
#line 106 "App.c"
}

GDesktopAppInfo*
backend_app_get_app_info (BackendApp* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 21 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 21 "../src/Backend/App.vala"
	result = _tmp0_;
#line 21 "../src/Backend/App.vala"
	return result;
#line 122 "App.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/Backend/App.vala"
	return self ? g_object_ref (self) : NULL;
#line 130 "App.c"
}

static void
backend_app_set_app_info (BackendApp* self,
                          GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 21 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Backend/App.vala"
	old_value = backend_app_get_app_info (self);
#line 21 "../src/Backend/App.vala"
	if (old_value != value) {
#line 144 "App.c"
		GDesktopAppInfo* _tmp0_;
#line 21 "../src/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Backend/App.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 21 "../src/Backend/App.vala"
		self->priv->_app_info = _tmp0_;
#line 21 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, backend_app_properties[BACKEND_APP_APP_INFO_PROPERTY]);
#line 154 "App.c"
	}
}

const gchar*
backend_app_get_app_id (BackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_app_id;
#line 22 "../src/Backend/App.vala"
	result = _tmp0_;
#line 22 "../src/Backend/App.vala"
	return result;
#line 171 "App.c"
}

static void
backend_app_set_app_id (BackendApp* self,
                        const gchar* value)
{
	gchar* old_value;
#line 22 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Backend/App.vala"
	old_value = backend_app_get_app_id (self);
#line 22 "../src/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 185 "App.c"
		gchar* _tmp0_;
#line 22 "../src/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../src/Backend/App.vala"
		_g_free0 (self->priv->_app_id);
#line 22 "../src/Backend/App.vala"
		self->priv->_app_id = _tmp0_;
#line 22 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, backend_app_properties[BACKEND_APP_APP_ID_PROPERTY]);
#line 195 "App.c"
	}
}

GSettings*
backend_app_get_settings (BackendApp* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 23 "../src/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_settings;
#line 23 "../src/Backend/App.vala"
	result = _tmp0_;
#line 23 "../src/Backend/App.vala"
	return result;
#line 212 "App.c"
}

static void
backend_app_set_settings (BackendApp* self,
                          GSettings* value)
{
	GSettings* old_value;
#line 23 "../src/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Backend/App.vala"
	old_value = backend_app_get_settings (self);
#line 23 "../src/Backend/App.vala"
	if (old_value != value) {
#line 226 "App.c"
		GSettings* _tmp0_;
#line 23 "../src/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Backend/App.vala"
		_g_object_unref0 (self->priv->_settings);
#line 23 "../src/Backend/App.vala"
		self->priv->_settings = _tmp0_;
#line 23 "../src/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, backend_app_properties[BACKEND_APP_SETTINGS_PROPERTY]);
#line 236 "App.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 259 "App.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 263 "App.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 269 "App.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 273 "App.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 277 "App.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 285 "App.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 313 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 322 "App.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 336 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 345 "App.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 359 "App.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 368 "App.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 377 "App.c"
}

static GObject *
backend_app_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BackendApp * self;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* child_schema_id = NULL;
	gchar* _tmp4_;
	gchar* child_path = NULL;
	gchar* _tmp5_;
	GSettingsSchemaSource* _tmp6_;
	const gchar* _tmp7_;
	GSettingsSchema* _tmp8_;
	GSettingsSchema* _tmp9_;
	gboolean _tmp10_;
	GSettingsSchemaSource* _tmp13_;
	const gchar* _tmp14_;
	GSettingsSchema* _tmp15_;
	GSettingsSchema* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
#line 29 "../src/Backend/App.vala"
	parent_class = G_OBJECT_CLASS (backend_app_parent_class);
#line 29 "../src/Backend/App.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 29 "../src/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BACKEND_TYPE_APP, BackendApp);
#line 30 "../src/Backend/App.vala"
	_tmp0_ = self->priv->_app_info;
#line 30 "../src/Backend/App.vala"
	_tmp1_ = g_app_info_get_id ((GAppInfo*) _tmp0_);
#line 30 "../src/Backend/App.vala"
	_tmp2_ = string_replace (_tmp1_, ".desktop", "");
#line 30 "../src/Backend/App.vala"
	_tmp3_ = _tmp2_;
#line 30 "../src/Backend/App.vala"
	backend_app_set_app_id (self, _tmp3_);
#line 30 "../src/Backend/App.vala"
	_g_free0 (_tmp3_);
#line 32 "../src/Backend/App.vala"
	_tmp4_ = g_strdup ("io.elementary.notifications.applications");
#line 32 "../src/Backend/App.vala"
	child_schema_id = _tmp4_;
#line 33 "../src/Backend/App.vala"
	_tmp5_ = g_strdup ("/io/elementary/notifications/applications/%s/");
#line 33 "../src/Backend/App.vala"
	child_path = _tmp5_;
#line 34 "../src/Backend/App.vala"
	_tmp6_ = g_settings_schema_source_get_default ();
#line 34 "../src/Backend/App.vala"
	_tmp7_ = child_schema_id;
#line 34 "../src/Backend/App.vala"
	_tmp8_ = g_settings_schema_source_lookup (_tmp6_, _tmp7_, TRUE);
#line 34 "../src/Backend/App.vala"
	_tmp9_ = _tmp8_;
#line 34 "../src/Backend/App.vala"
	_tmp10_ = _tmp9_ == NULL;
#line 34 "../src/Backend/App.vala"
	_g_settings_schema_unref0 (_tmp9_);
#line 34 "../src/Backend/App.vala"
	if (_tmp10_) {
#line 451 "App.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 35 "../src/Backend/App.vala"
		_tmp11_ = g_strdup ("org.pantheon.desktop.gala.notifications.application");
#line 35 "../src/Backend/App.vala"
		_g_free0 (child_schema_id);
#line 35 "../src/Backend/App.vala"
		child_schema_id = _tmp11_;
#line 36 "../src/Backend/App.vala"
		_tmp12_ = g_strdup ("/org/pantheon/desktop/gala/notifications/applications/%s/");
#line 36 "../src/Backend/App.vala"
		_g_free0 (child_path);
#line 36 "../src/Backend/App.vala"
		child_path = _tmp12_;
#line 466 "App.c"
	}
#line 39 "../src/Backend/App.vala"
	_tmp13_ = g_settings_schema_source_get_default ();
#line 39 "../src/Backend/App.vala"
	_tmp14_ = child_schema_id;
#line 39 "../src/Backend/App.vala"
	_tmp15_ = g_settings_schema_source_lookup (_tmp13_, _tmp14_, TRUE);
#line 39 "../src/Backend/App.vala"
	_tmp16_ = _tmp15_;
#line 39 "../src/Backend/App.vala"
	_tmp17_ = child_path;
#line 39 "../src/Backend/App.vala"
	_tmp18_ = self->priv->_app_id;
#line 39 "../src/Backend/App.vala"
	_tmp19_ = g_strdup_printf (_tmp17_, _tmp18_);
#line 39 "../src/Backend/App.vala"
	_tmp20_ = _tmp19_;
#line 39 "../src/Backend/App.vala"
	_tmp21_ = g_settings_new_full (_tmp16_, NULL, _tmp20_);
#line 39 "../src/Backend/App.vala"
	_tmp22_ = _tmp21_;
#line 39 "../src/Backend/App.vala"
	backend_app_set_settings (self, _tmp22_);
#line 39 "../src/Backend/App.vala"
	_g_object_unref0 (_tmp22_);
#line 39 "../src/Backend/App.vala"
	_g_free0 (_tmp20_);
#line 39 "../src/Backend/App.vala"
	_g_settings_schema_unref0 (_tmp16_);
#line 29 "../src/Backend/App.vala"
	_g_free0 (child_path);
#line 29 "../src/Backend/App.vala"
	_g_free0 (child_schema_id);
#line 29 "../src/Backend/App.vala"
	return obj;
#line 502 "App.c"
}

static void
backend_app_class_init (BackendAppClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/Backend/App.vala"
	backend_app_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/App.vala"
	g_type_class_adjust_private_offset (klass, &BackendApp_private_offset);
#line 20 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_backend_app_get_property;
#line 20 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_backend_app_set_property;
#line 20 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->constructor = backend_app_constructor;
#line 20 "../src/Backend/App.vala"
	G_OBJECT_CLASS (klass)->finalize = backend_app_finalize;
#line 20 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKEND_APP_APP_INFO_PROPERTY, backend_app_properties[BACKEND_APP_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKEND_APP_APP_ID_PROPERTY, backend_app_properties[BACKEND_APP_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKEND_APP_SETTINGS_PROPERTY, backend_app_properties[BACKEND_APP_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 527 "App.c"
}

static void
backend_app_instance_init (BackendApp * self,
                           gpointer klass)
{
#line 20 "../src/Backend/App.vala"
	self->priv = backend_app_get_instance_private (self);
#line 536 "App.c"
}

static void
backend_app_finalize (GObject * obj)
{
	BackendApp * self;
#line 20 "../src/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BACKEND_TYPE_APP, BackendApp);
#line 21 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 22 "../src/Backend/App.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../src/Backend/App.vala"
	_g_object_unref0 (self->priv->_settings);
#line 20 "../src/Backend/App.vala"
	G_OBJECT_CLASS (backend_app_parent_class)->finalize (obj);
#line 553 "App.c"
}

static GType
backend_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackendAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backend_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackendApp), 0, (GInstanceInitFunc) backend_app_instance_init, NULL };
	GType backend_app_type_id;
	backend_app_type_id = g_type_register_static (G_TYPE_OBJECT, "BackendApp", &g_define_type_info, 0);
	BackendApp_private_offset = g_type_add_instance_private (backend_app_type_id, sizeof (BackendAppPrivate));
	return backend_app_type_id;
}

GType
backend_app_get_type (void)
{
	static volatile gsize backend_app_type_id__once = 0;
	if (g_once_init_enter (&backend_app_type_id__once)) {
		GType backend_app_type_id;
		backend_app_type_id = backend_app_get_type_once ();
		g_once_init_leave (&backend_app_type_id__once, backend_app_type_id);
	}
	return backend_app_type_id__once;
}

static void
_vala_backend_app_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	BackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BACKEND_TYPE_APP, BackendApp);
#line 20 "../src/Backend/App.vala"
	switch (property_id) {
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_APP_INFO_PROPERTY:
#line 20 "../src/Backend/App.vala"
		g_value_set_object (value, backend_app_get_app_info (self));
#line 20 "../src/Backend/App.vala"
		break;
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_APP_ID_PROPERTY:
#line 20 "../src/Backend/App.vala"
		g_value_set_string (value, backend_app_get_app_id (self));
#line 20 "../src/Backend/App.vala"
		break;
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_SETTINGS_PROPERTY:
#line 20 "../src/Backend/App.vala"
		g_value_set_object (value, backend_app_get_settings (self));
#line 20 "../src/Backend/App.vala"
		break;
#line 606 "App.c"
		default:
#line 20 "../src/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Backend/App.vala"
		break;
#line 612 "App.c"
	}
}

static void
_vala_backend_app_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	BackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BACKEND_TYPE_APP, BackendApp);
#line 20 "../src/Backend/App.vala"
	switch (property_id) {
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_APP_INFO_PROPERTY:
#line 20 "../src/Backend/App.vala"
		backend_app_set_app_info (self, g_value_get_object (value));
#line 20 "../src/Backend/App.vala"
		break;
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_APP_ID_PROPERTY:
#line 20 "../src/Backend/App.vala"
		backend_app_set_app_id (self, g_value_get_string (value));
#line 20 "../src/Backend/App.vala"
		break;
#line 20 "../src/Backend/App.vala"
		case BACKEND_APP_SETTINGS_PROPERTY:
#line 20 "../src/Backend/App.vala"
		backend_app_set_settings (self, g_value_get_object (value));
#line 20 "../src/Backend/App.vala"
		break;
#line 644 "App.c"
		default:
#line 20 "../src/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Backend/App.vala"
		break;
#line 650 "App.c"
	}
}

