/* AppEntry.c generated by valac 0.56.18, the Vala compiler
 * generated from AppEntry.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "notifications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gio/gdesktopappinfo.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <granite.h>

#define WIDGETS_APP_ENTRY_BUBBLES_KEY "bubbles"
#define WIDGETS_APP_ENTRY_SOUNDS_KEY "sounds"
#define WIDGETS_APP_ENTRY_REMEMBER_KEY "remember"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_APP_ENTRY_0_PROPERTY,
	WIDGETS_APP_ENTRY_APP_PROPERTY,
	WIDGETS_APP_ENTRY_NUM_PROPERTIES
};
static GParamSpec* widgets_app_entry_properties[WIDGETS_APP_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;

struct _WidgetsAppEntryPrivate {
	BackendApp* _app;
};

struct _Block2Data {
	int _ref_count_;
	WidgetsAppEntry* self;
	GtkLabel* description_label;
};

static gint WidgetsAppEntry_private_offset;
static gpointer widgets_app_entry_parent_class = NULL;

static gchar* widgets_app_entry_get_permissions_string (WidgetsAppEntry* self,
                                                 BackendApp* app);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * widgets_app_entry_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _widgets_app_entry___lambda4_ (Block2Data* _data2_);
static void __widgets_app_entry___lambda4__g_settings_changed (GSettings* _sender,
                                                        const gchar* key,
                                                        gpointer self);
static void widgets_app_entry_finalize (GObject * obj);
static GType widgets_app_entry_get_type_once (void);
static void _vala_widgets_app_entry_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_widgets_app_entry_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_app_entry_get_instance_private (WidgetsAppEntry* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsAppEntry_private_offset);
}

WidgetsAppEntry*
widgets_app_entry_construct (GType object_type,
                             BackendApp* app)
{
	WidgetsAppEntry * self = NULL;
#line 27 "../src/Widgets/AppEntry.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 28 "../src/Widgets/AppEntry.vala"
	self = (WidgetsAppEntry*) g_object_new (object_type, "app", app, NULL);
#line 27 "../src/Widgets/AppEntry.vala"
	return self;
#line 134 "AppEntry.c"
}

WidgetsAppEntry*
widgets_app_entry_new (BackendApp* app)
{
#line 27 "../src/Widgets/AppEntry.vala"
	return widgets_app_entry_construct (WIDGETS_TYPE_APP_ENTRY, app);
#line 142 "AppEntry.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 69 "../src/Widgets/AppEntry.vala"
	if ((*length) == (*size)) {
#line 69 "../src/Widgets/AppEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 69 "../src/Widgets/AppEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 157 "AppEntry.c"
	}
#line 69 "../src/Widgets/AppEntry.vala"
	(*array)[(*length)++] = value;
#line 69 "../src/Widgets/AppEntry.vala"
	(*array)[*length] = NULL;
#line 163 "AppEntry.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 73 "../src/Widgets/AppEntry.vala"
	if ((*length) == (*size)) {
#line 73 "../src/Widgets/AppEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 73 "../src/Widgets/AppEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 178 "AppEntry.c"
	}
#line 73 "../src/Widgets/AppEntry.vala"
	(*array)[(*length)++] = value;
#line 73 "../src/Widgets/AppEntry.vala"
	(*array)[*length] = NULL;
#line 184 "AppEntry.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 77 "../src/Widgets/AppEntry.vala"
	if ((*length) == (*size)) {
#line 77 "../src/Widgets/AppEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 77 "../src/Widgets/AppEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 199 "AppEntry.c"
	}
#line 77 "../src/Widgets/AppEntry.vala"
	(*array)[(*length)++] = value;
#line 77 "../src/Widgets/AppEntry.vala"
	(*array)[*length] = NULL;
#line 205 "AppEntry.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 81 "../src/Widgets/AppEntry.vala"
	if ((*length) == (*size)) {
#line 81 "../src/Widgets/AppEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 81 "../src/Widgets/AppEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 220 "AppEntry.c"
	}
#line 81 "../src/Widgets/AppEntry.vala"
	(*array)[(*length)++] = value;
#line 81 "../src/Widgets/AppEntry.vala"
	(*array)[*length] = NULL;
#line 226 "AppEntry.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 240 "AppEntry.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 244 "AppEntry.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 250 "AppEntry.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 255 "AppEntry.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 261 "AppEntry.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 265 "AppEntry.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 269 "AppEntry.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 273 "AppEntry.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 277 "AppEntry.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 281 "AppEntry.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 296 "AppEntry.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 305 "AppEntry.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 312 "AppEntry.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 318 "AppEntry.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 326 "AppEntry.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 330 "AppEntry.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 336 "AppEntry.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 341 "AppEntry.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 347 "AppEntry.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 351 "AppEntry.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 355 "AppEntry.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 361 "AppEntry.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 367 "AppEntry.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 379 "AppEntry.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 383 "AppEntry.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 387 "AppEntry.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 392 "AppEntry.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 400 "AppEntry.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 418 "AppEntry.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 424 "AppEntry.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 428 "AppEntry.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 436 "AppEntry.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 445 "AppEntry.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 454 "AppEntry.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 460 "AppEntry.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 468 "AppEntry.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 480 "AppEntry.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 486 "AppEntry.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 490 "AppEntry.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 498 "AppEntry.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 509 "AppEntry.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 518 "AppEntry.c"
	}
}

static gchar*
widgets_app_entry_get_permissions_string (WidgetsAppEntry* self,
                                          BackendApp* app)
{
	gchar** items = NULL;
	gchar** _tmp0_;
	gint items_length1;
	gint _items_size_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* result;
#line 65 "../src/Widgets/AppEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/Widgets/AppEntry.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 66 "../src/Widgets/AppEntry.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 66 "../src/Widgets/AppEntry.vala"
	items = _tmp0_;
#line 66 "../src/Widgets/AppEntry.vala"
	items_length1 = 0;
#line 66 "../src/Widgets/AppEntry.vala"
	_items_size_ = items_length1;
#line 68 "../src/Widgets/AppEntry.vala"
	_tmp1_ = backend_app_get_settings (app);
#line 68 "../src/Widgets/AppEntry.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/Widgets/AppEntry.vala"
	if (g_settings_get_boolean (_tmp2_, WIDGETS_APP_ENTRY_BUBBLES_KEY)) {
#line 565 "AppEntry.c"
		gchar* _tmp3_;
#line 69 "../src/Widgets/AppEntry.vala"
		_tmp3_ = g_strdup (_ ("Bubbles"));
#line 69 "../src/Widgets/AppEntry.vala"
		_vala_array_add1 (&items, &items_length1, &_items_size_, _tmp3_);
#line 571 "AppEntry.c"
	}
#line 72 "../src/Widgets/AppEntry.vala"
	_tmp4_ = backend_app_get_settings (app);
#line 72 "../src/Widgets/AppEntry.vala"
	_tmp5_ = _tmp4_;
#line 72 "../src/Widgets/AppEntry.vala"
	if (g_settings_get_boolean (_tmp5_, WIDGETS_APP_ENTRY_SOUNDS_KEY)) {
#line 579 "AppEntry.c"
		gchar* _tmp6_;
#line 73 "../src/Widgets/AppEntry.vala"
		_tmp6_ = g_strdup (_ ("Sounds"));
#line 73 "../src/Widgets/AppEntry.vala"
		_vala_array_add2 (&items, &items_length1, &_items_size_, _tmp6_);
#line 585 "AppEntry.c"
	}
#line 76 "../src/Widgets/AppEntry.vala"
	_tmp7_ = backend_app_get_settings (app);
#line 76 "../src/Widgets/AppEntry.vala"
	_tmp8_ = _tmp7_;
#line 76 "../src/Widgets/AppEntry.vala"
	if (g_settings_get_boolean (_tmp8_, WIDGETS_APP_ENTRY_REMEMBER_KEY)) {
#line 593 "AppEntry.c"
		gchar* _tmp9_;
#line 77 "../src/Widgets/AppEntry.vala"
		_tmp9_ = g_strdup (_ ("Notification Center"));
#line 77 "../src/Widgets/AppEntry.vala"
		_vala_array_add3 (&items, &items_length1, &_items_size_, _tmp9_);
#line 599 "AppEntry.c"
	}
#line 80 "../src/Widgets/AppEntry.vala"
	_tmp10_ = items;
#line 80 "../src/Widgets/AppEntry.vala"
	_tmp10__length1 = items_length1;
#line 80 "../src/Widgets/AppEntry.vala"
	if (_tmp10__length1 == 0) {
#line 607 "AppEntry.c"
		gchar* _tmp11_;
#line 81 "../src/Widgets/AppEntry.vala"
		_tmp11_ = g_strdup (_ ("Disabled"));
#line 81 "../src/Widgets/AppEntry.vala"
		_vala_array_add4 (&items, &items_length1, &_items_size_, _tmp11_);
#line 613 "AppEntry.c"
	}
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp12_ = items;
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp12__length1 = items_length1;
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp13_ = _vala_g_strjoinv (", ", _tmp12_, (gint) _tmp12__length1);
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp14_ = _tmp13_;
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp15_ = g_markup_escape_text (_tmp14_, (gssize) -1);
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp16_ = _tmp15_;
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp17_ = g_strdup_printf ("<span font_size=\"small\">%s</span>", _tmp16_);
#line 84 "../src/Widgets/AppEntry.vala"
	_tmp18_ = _tmp17_;
#line 84 "../src/Widgets/AppEntry.vala"
	_g_free0 (_tmp16_);
#line 84 "../src/Widgets/AppEntry.vala"
	_g_free0 (_tmp14_);
#line 84 "../src/Widgets/AppEntry.vala"
	result = _tmp18_;
#line 84 "../src/Widgets/AppEntry.vala"
	items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/Widgets/AppEntry.vala"
	return result;
#line 641 "AppEntry.c"
}

BackendApp*
widgets_app_entry_get_app (WidgetsAppEntry* self)
{
	BackendApp* result;
	BackendApp* _tmp0_;
#line 25 "../src/Widgets/AppEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/AppEntry.vala"
	_tmp0_ = self->priv->_app;
#line 25 "../src/Widgets/AppEntry.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/AppEntry.vala"
	return result;
#line 657 "AppEntry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../src/Widgets/AppEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 665 "AppEntry.c"
}

static void
widgets_app_entry_set_app (WidgetsAppEntry* self,
                           BackendApp* value)
{
	BackendApp* old_value;
#line 25 "../src/Widgets/AppEntry.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/AppEntry.vala"
	old_value = widgets_app_entry_get_app (self);
#line 25 "../src/Widgets/AppEntry.vala"
	if (old_value != value) {
#line 679 "AppEntry.c"
		BackendApp* _tmp0_;
#line 25 "../src/Widgets/AppEntry.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Widgets/AppEntry.vala"
		_g_object_unref0 (self->priv->_app);
#line 25 "../src/Widgets/AppEntry.vala"
		self->priv->_app = _tmp0_;
#line 25 "../src/Widgets/AppEntry.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_app_entry_properties[WIDGETS_APP_ENTRY_APP_PROPERTY]);
#line 689 "AppEntry.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 31 "../src/Widgets/AppEntry.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 31 "../src/Widgets/AppEntry.vala"
	return _data2_;
#line 700 "AppEntry.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 31 "../src/Widgets/AppEntry.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 710 "AppEntry.c"
		WidgetsAppEntry* self;
#line 31 "../src/Widgets/AppEntry.vala"
		self = _data2_->self;
#line 31 "../src/Widgets/AppEntry.vala"
		_g_object_unref0 (_data2_->description_label);
#line 31 "../src/Widgets/AppEntry.vala"
		_g_object_unref0 (self);
#line 31 "../src/Widgets/AppEntry.vala"
		g_slice_free (Block2Data, _data2_);
#line 720 "AppEntry.c"
	}
}

static void
_widgets_app_entry___lambda4_ (Block2Data* _data2_)
{
	WidgetsAppEntry* self;
	GtkLabel* _tmp0_;
	BackendApp* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 60 "../src/Widgets/AppEntry.vala"
	self = _data2_->self;
#line 61 "../src/Widgets/AppEntry.vala"
	_tmp0_ = _data2_->description_label;
#line 61 "../src/Widgets/AppEntry.vala"
	_tmp1_ = self->priv->_app;
#line 61 "../src/Widgets/AppEntry.vala"
	_tmp2_ = widgets_app_entry_get_permissions_string (self, _tmp1_);
#line 61 "../src/Widgets/AppEntry.vala"
	_tmp3_ = _tmp2_;
#line 61 "../src/Widgets/AppEntry.vala"
	gtk_label_set_markup (_tmp0_, _tmp3_);
#line 61 "../src/Widgets/AppEntry.vala"
	_g_free0 (_tmp3_);
#line 746 "AppEntry.c"
}

static void
__widgets_app_entry___lambda4__g_settings_changed (GSettings* _sender,
                                                   const gchar* key,
                                                   gpointer self)
{
#line 60 "../src/Widgets/AppEntry.vala"
	_widgets_app_entry___lambda4_ (self);
#line 756 "AppEntry.c"
}

static GObject *
widgets_app_entry_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsAppEntry * self;
	Block2Data* _data2_;
	GtkImage* image = NULL;
	BackendApp* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GIcon* _tmp3_;
	GtkImage* _tmp4_ = NULL;
	GtkLabel* title_label = NULL;
	BackendApp* _tmp5_;
	GDesktopAppInfo* _tmp6_;
	GDesktopAppInfo* _tmp7_;
	const gchar* _tmp8_;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	BackendApp* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkLabel* _tmp15_ = NULL;
	GtkLabel* _tmp16_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_;
	GtkImage* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	BackendApp* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
#line 31 "../src/Widgets/AppEntry.vala"
	parent_class = G_OBJECT_CLASS (widgets_app_entry_parent_class);
#line 31 "../src/Widgets/AppEntry.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Widgets/AppEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry);
#line 31 "../src/Widgets/AppEntry.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 31 "../src/Widgets/AppEntry.vala"
	_data2_->_ref_count_ = 1;
#line 31 "../src/Widgets/AppEntry.vala"
	_data2_->self = g_object_ref (self);
#line 32 "../src/Widgets/AppEntry.vala"
	_tmp0_ = self->priv->_app;
#line 32 "../src/Widgets/AppEntry.vala"
	_tmp1_ = backend_app_get_app_info (_tmp0_);
#line 32 "../src/Widgets/AppEntry.vala"
	_tmp2_ = _tmp1_;
#line 32 "../src/Widgets/AppEntry.vala"
	_tmp3_ = g_app_info_get_icon ((GAppInfo*) _tmp2_);
#line 32 "../src/Widgets/AppEntry.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_gicon (_tmp3_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 32 "../src/Widgets/AppEntry.vala"
	gtk_image_set_pixel_size (_tmp4_, 32);
#line 32 "../src/Widgets/AppEntry.vala"
	g_object_ref_sink (_tmp4_);
#line 32 "../src/Widgets/AppEntry.vala"
	image = _tmp4_;
#line 36 "../src/Widgets/AppEntry.vala"
	_tmp5_ = self->priv->_app;
#line 36 "../src/Widgets/AppEntry.vala"
	_tmp6_ = backend_app_get_app_info (_tmp5_);
#line 36 "../src/Widgets/AppEntry.vala"
	_tmp7_ = _tmp6_;
#line 36 "../src/Widgets/AppEntry.vala"
	_tmp8_ = g_app_info_get_display_name ((GAppInfo*) _tmp7_);
#line 36 "../src/Widgets/AppEntry.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 36 "../src/Widgets/AppEntry.vala"
	gtk_label_set_ellipsize (_tmp9_, PANGO_ELLIPSIZE_END);
#line 36 "../src/Widgets/AppEntry.vala"
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
#line 36 "../src/Widgets/AppEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
#line 36 "../src/Widgets/AppEntry.vala"
	g_object_ref_sink (_tmp9_);
#line 36 "../src/Widgets/AppEntry.vala"
	title_label = _tmp9_;
#line 41 "../src/Widgets/AppEntry.vala"
	_tmp10_ = title_label;
#line 41 "../src/Widgets/AppEntry.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 41 "../src/Widgets/AppEntry.vala"
	gtk_style_context_add_class (_tmp11_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 43 "../src/Widgets/AppEntry.vala"
	_tmp12_ = self->priv->_app;
#line 43 "../src/Widgets/AppEntry.vala"
	_tmp13_ = widgets_app_entry_get_permissions_string (self, _tmp12_);
#line 43 "../src/Widgets/AppEntry.vala"
	_tmp14_ = _tmp13_;
#line 43 "../src/Widgets/AppEntry.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_tmp14_);
#line 43 "../src/Widgets/AppEntry.vala"
	gtk_label_set_use_markup (_tmp15_, TRUE);
#line 43 "../src/Widgets/AppEntry.vala"
	gtk_label_set_ellipsize (_tmp15_, PANGO_ELLIPSIZE_END);
#line 43 "../src/Widgets/AppEntry.vala"
	gtk_label_set_xalign (_tmp15_, (gfloat) 0);
#line 43 "../src/Widgets/AppEntry.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_START);
#line 43 "../src/Widgets/AppEntry.vala"
	g_object_ref_sink (_tmp15_);
#line 43 "../src/Widgets/AppEntry.vala"
	_tmp16_ = _tmp15_;
#line 43 "../src/Widgets/AppEntry.vala"
	_g_free0 (_tmp14_);
#line 43 "../src/Widgets/AppEntry.vala"
	_data2_->description_label = _tmp16_;
#line 50 "../src/Widgets/AppEntry.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 50 "../src/Widgets/AppEntry.vala"
	g_object_set ((GtkWidget*) _tmp17_, "margin", 6, NULL);
#line 50 "../src/Widgets/AppEntry.vala"
	gtk_grid_set_column_spacing (_tmp17_, 6);
#line 50 "../src/Widgets/AppEntry.vala"
	g_object_ref_sink (_tmp17_);
#line 50 "../src/Widgets/AppEntry.vala"
	grid = _tmp17_;
#line 54 "../src/Widgets/AppEntry.vala"
	_tmp18_ = grid;
#line 54 "../src/Widgets/AppEntry.vala"
	_tmp19_ = image;
#line 54 "../src/Widgets/AppEntry.vala"
	gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 2);
#line 55 "../src/Widgets/AppEntry.vala"
	_tmp20_ = grid;
#line 55 "../src/Widgets/AppEntry.vala"
	_tmp21_ = title_label;
#line 55 "../src/Widgets/AppEntry.vala"
	gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 1, 0, 1, 1);
#line 56 "../src/Widgets/AppEntry.vala"
	_tmp22_ = grid;
#line 56 "../src/Widgets/AppEntry.vala"
	_tmp23_ = _data2_->description_label;
#line 56 "../src/Widgets/AppEntry.vala"
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 1, 1, 1, 1);
#line 58 "../src/Widgets/AppEntry.vala"
	_tmp24_ = grid;
#line 58 "../src/Widgets/AppEntry.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 60 "../src/Widgets/AppEntry.vala"
	_tmp25_ = self->priv->_app;
#line 60 "../src/Widgets/AppEntry.vala"
	_tmp26_ = backend_app_get_settings (_tmp25_);
#line 60 "../src/Widgets/AppEntry.vala"
	_tmp27_ = _tmp26_;
#line 60 "../src/Widgets/AppEntry.vala"
	g_signal_connect_data (_tmp27_, "changed", (GCallback) __widgets_app_entry___lambda4__g_settings_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 31 "../src/Widgets/AppEntry.vala"
	_g_object_unref0 (grid);
#line 31 "../src/Widgets/AppEntry.vala"
	_g_object_unref0 (title_label);
#line 31 "../src/Widgets/AppEntry.vala"
	_g_object_unref0 (image);
#line 31 "../src/Widgets/AppEntry.vala"
	block2_data_unref (_data2_);
#line 31 "../src/Widgets/AppEntry.vala"
	_data2_ = NULL;
#line 31 "../src/Widgets/AppEntry.vala"
	return obj;
#line 929 "AppEntry.c"
}

static void
widgets_app_entry_class_init (WidgetsAppEntryClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/Widgets/AppEntry.vala"
	widgets_app_entry_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/AppEntry.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsAppEntry_private_offset);
#line 20 "../src/Widgets/AppEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_app_entry_get_property;
#line 20 "../src/Widgets/AppEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_app_entry_set_property;
#line 20 "../src/Widgets/AppEntry.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_app_entry_constructor;
#line 20 "../src/Widgets/AppEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_app_entry_finalize;
#line 20 "../src/Widgets/AppEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_APP_ENTRY_APP_PROPERTY, widgets_app_entry_properties[WIDGETS_APP_ENTRY_APP_PROPERTY] = g_param_spec_object ("app", "app", "app", BACKEND_TYPE_APP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 950 "AppEntry.c"
}

static void
widgets_app_entry_instance_init (WidgetsAppEntry * self,
                                 gpointer klass)
{
#line 20 "../src/Widgets/AppEntry.vala"
	self->priv = widgets_app_entry_get_instance_private (self);
#line 959 "AppEntry.c"
}

static void
widgets_app_entry_finalize (GObject * obj)
{
	WidgetsAppEntry * self;
#line 20 "../src/Widgets/AppEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry);
#line 25 "../src/Widgets/AppEntry.vala"
	_g_object_unref0 (self->priv->_app);
#line 20 "../src/Widgets/AppEntry.vala"
	G_OBJECT_CLASS (widgets_app_entry_parent_class)->finalize (obj);
#line 972 "AppEntry.c"
}

static GType
widgets_app_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsAppEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_app_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsAppEntry), 0, (GInstanceInitFunc) widgets_app_entry_instance_init, NULL };
	GType widgets_app_entry_type_id;
	widgets_app_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WidgetsAppEntry", &g_define_type_info, 0);
	WidgetsAppEntry_private_offset = g_type_add_instance_private (widgets_app_entry_type_id, sizeof (WidgetsAppEntryPrivate));
	return widgets_app_entry_type_id;
}

GType
widgets_app_entry_get_type (void)
{
	static volatile gsize widgets_app_entry_type_id__once = 0;
	if (g_once_init_enter (&widgets_app_entry_type_id__once)) {
		GType widgets_app_entry_type_id;
		widgets_app_entry_type_id = widgets_app_entry_get_type_once ();
		g_once_init_leave (&widgets_app_entry_type_id__once, widgets_app_entry_type_id);
	}
	return widgets_app_entry_type_id__once;
}

static void
_vala_widgets_app_entry_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsAppEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry);
#line 20 "../src/Widgets/AppEntry.vala"
	switch (property_id) {
#line 20 "../src/Widgets/AppEntry.vala"
		case WIDGETS_APP_ENTRY_APP_PROPERTY:
#line 20 "../src/Widgets/AppEntry.vala"
		g_value_set_object (value, widgets_app_entry_get_app (self));
#line 20 "../src/Widgets/AppEntry.vala"
		break;
#line 1013 "AppEntry.c"
		default:
#line 20 "../src/Widgets/AppEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/AppEntry.vala"
		break;
#line 1019 "AppEntry.c"
	}
}

static void
_vala_widgets_app_entry_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsAppEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry);
#line 20 "../src/Widgets/AppEntry.vala"
	switch (property_id) {
#line 20 "../src/Widgets/AppEntry.vala"
		case WIDGETS_APP_ENTRY_APP_PROPERTY:
#line 20 "../src/Widgets/AppEntry.vala"
		widgets_app_entry_set_app (self, g_value_get_object (value));
#line 20 "../src/Widgets/AppEntry.vala"
		break;
#line 1039 "AppEntry.c"
		default:
#line 20 "../src/Widgets/AppEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/AppEntry.vala"
		break;
#line 1045 "AppEntry.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

